summaryrefslogtreecommitdiff
path: root/bin/pkgneedsbuild
diff options
context:
space:
mode:
authorMike Gabriel <mike.gabriel@das-netzwerkteam.de>2011-12-20 21:26:26 +0100
committerMike Gabriel <mike.gabriel@das-netzwerkteam.de>2011-12-20 21:26:26 +0100
commitbaf582456e485e2e4272c0b888f9ccdb10cde499 (patch)
tree029cf372e26399b49e9b922539090528fb403d61 /bin/pkgneedsbuild
parent2533ac9afb98f8e5b236fec73f1b985ab94f8ff6 (diff)
downloadbuildscripts-baf582456e485e2e4272c0b888f9ccdb10cde499.tar.gz
buildscripts-baf582456e485e2e4272c0b888f9ccdb10cde499.tar.bz2
buildscripts-baf582456e485e2e4272c0b888f9ccdb10cde499.zip
reworked buildscripts completely, so that they can be used for several projects
Diffstat (limited to 'bin/pkgneedsbuild')
-rwxr-xr-xbin/pkgneedsbuild47
1 files changed, 47 insertions, 0 deletions
diff --git a/bin/pkgneedsbuild b/bin/pkgneedsbuild
new file mode 100755
index 0000000..2a192eb
--- /dev/null
+++ b/bin/pkgneedsbuild
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+# Copyright (C) 2010-2011 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
+#
+# This is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the
+# Free Software Foundation, Inc.,
+# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+
+set -xe
+
+CHECKOUT=${1:-master}
+
+[ -d .git ] && {
+
+ TIMESTAMP=$(date +%s)
+ CURRENT_BRANCH=$(git branch | grep "*" | awk '{print $2}')
+
+ # switch to branch given as $CHECKOUT, if it does not exist locally, create it...
+ git checkout $CHECKOUT &>/dev/null || git checkout -b $CHECKOUT >/dev/null
+
+ # switch to a tmp branch...
+ git checkout -b tmp-$TIMESTAMP &>/dev/null
+
+ # pull $CHECKOUT from origin into the tmp branch
+ LANG=en_US.UTF-8 git pull origin $CHECKOUT 2>/dev/null | egrep "^Already up-to-date.$" &>/dev/null && {
+ # drop the tmp branch
+ git checkout $CURRENT_BRANCH &>/dev/null
+ git branch -D tmp-$TIMESTAMP >/dev/null
+ exit 1
+ } || {
+ # drop the tmp branch
+ git checkout $CURRENT_BRANCH &>/dev/null
+ git branch -D tmp-$TIMESTAMP >/dev/null
+ exit 0
+ }
+} || exit 0